unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls, Vcl.ExtCtrls,
  VCLTee.Series, VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart, system.UITypes, system.Math;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Memo1: TMemo;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    Button1: TButton;
    Series1: TBarSeries;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ************ loggamma(x) ************
const
  N =      8;

  B0 = 1;                 // ȉBernoulli
  B1 = (-1.0 / 2.0);
  B2 = ( 1.0 / 6.0);
  B4 = (-1.0 / 30.0);
  B6 = ( 1.0 / 42.0);
  B8 = (-1.0 / 30.0);
  B10 = ( 5.0 / 66.0);
  B12 = (-691.0 / 2730.0);
  B14 = ( 7.0 / 6.0);
  B16 = (-3617.0 / 510.0);


function  loggamma(x : double): double;  // K}֐̑ΐ
var
  LOG_2PI : Double;
  v, w  : Double;
begin
	v := 1;
	while x < N do begin
    v :=  v * x;
    x := x + 1;
  end;
  LOG_2PI := ln(2 * pi);
	w := 1 / (x * x);
	result := ((((((((B16 / (16 * 15))  * w + (B14 / (14 * 13))) * w
	            + (B12 / (12 * 11))) * w + (B10 / (10 *  9))) * w
	            + (B8  / ( 8 *  7))) * w + (B6  / ( 6 *  5))) * w
	            + (B4  / ( 4 *  3))) * w + (B2  / ( 2 *  1))) / x
	            + 0.5 * LOG_2PI - ln(v) - x + (x - 0.5) * ln(x);
end;

// x[^֐
function p_beta(x, a, b : double): double;
var
	k : integer;
	p1, q1, p2, q2, d, previous : double;
begin
	if a <= 0 then begin
    result :=  MaxDouble;
    exit;
  end;
	if b <= 0 then begin
		if x <  1 then begin
      result := 0;
      exit;
    end;
		if x = 1 then begin
      result := 1;
      exit;
    end;
		result :=  MaxDouble;
    exit;
	end;
	if x > (a + 1) / (a + b + 2) then begin
		result := 1 - p_beta(1 - x, b, a);
    exit;
  end;
	if x <= 0 then begin
    result := 0;
    exit;
  end;
	p1 := 0;
  q1 := 1;
	p2 := exp(a * ln(x) + b * ln(1 - x)
		+ loggamma(a + b) - loggamma(a) - loggamma(b)) / a;
	q2 := 1;
  k := 0;
	while k < 200 do begin
		previous := p2;
		d := - (a + k) * (a + b + k) * x
			/ ((a + 2 * k) * (a + 2 * k + 1));
		p1 := p1 * d + p2;
    q1 := q1 * d + q2;
		inc(k);
		d := k * (b - k) * x / ((a + 2 * k - 1) * (a + 2 * k));
		p2 := p2 * d + p1;
    q2 := q2 * d + q1;
		if q2 = 0 then begin
			p2 := Maxdouble;
      continue;
    end;
		p1 := p1 / q2;
    q1 := q1 / q2;
    p2 := p2 / q2;
    q2 := 1;
		if p2 = previous then begin
      result := p2;
      exit;
    end;
	end;
	Form1.Memo1.Lines.Add('p_beta: ܂');
	result := p2;
end;

function q_beta(x, a, b: double): double;
begin
	result := 1 - p_beta(x, a, b);
end;

//**********************************************************

// 2z B(n,p)  X <= k ̊m
function p_binomial(n: integer; p: double; k: integer): double;
begin
	if k <  0 then begin
    result := 0;
    exit;
  end;
	if k >= n then begin
    result := 1;
    exit;
  end;
	result := p_beta(1 - p, n - k, k + 1);
end;

// 2z B(n,p)  X >= k ̊m
function q_binomial(n: integer; p: double; k: integer): double;
begin
	if k <= 0 then begin
    result := 1;
    exit;
  end;
	if k >  n then begin
    result := 0;
    exit;
  end;
	result := p_beta(p, k, n - k + 1);
end;

//**********************************************************

// 2z mx1
function binomial_mass(n: integer; p: double; k: integer): double;
var
  nCx: double;
begin
  nCx := exp(loggamma(n + 1) - loggamma(k + 1) - loggamma(n - k + 1));
  result := nCx * power(p, k) * power(1 - p, n - k);
end;

// 2z mx2
function binomial_f(n: integer; p: double; k: integer): double;
var
  q : double;
  t : double;
  i : integer;
begin
  q := 1 - p;
  t := power(q, n);
  for i := 0 to k - 1 do
    t := t * (n - i) * p / ((i + 1) * q);
  result := t;
end;

//**********************************************************/

procedure TForm1.Button1Click(Sender: TObject);
var
  ch   : integer;
  n, x : integer;     // n s x 
  p : double;         // p ꎎs̐m
  Po, Qo : double;
  fo: double;
  I: Integer;
begin
  val(LabeledEdit1.Text, n, Ch);
  if ch <> 0 then begin
    MessageDlg('nlɊԈႢ܂B', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  if n <= 0 then begin
    MessageDlg('n̒l[傫ĂB', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit2.Text, p, Ch);
  if ch <> 0 then begin
    MessageDlg('plɊԈႢ܂B', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  if p < 0 then begin
    MessageDlg('p̒l[ȉłB', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  if p > 1 then begin
    MessageDlg('p̒lP傫łB', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit3.Text, x, Ch);
  if ch <> 0 then begin
    MessageDlg('xlɊԈႢ܂B', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  if x < 0 then begin
    MessageDlg('x̒l[ȉłB', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  if x > n then begin
    MessageDlg('x̒ln傫łB', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;

  Memo1.Clear;
  {$IFDEF CPUX64}                               // vbgtH[64rbg
  begin
    Memo1.Lines.Add('X64[h');
  end;
  {$ENDIF CPUX64}
  {$IFDEF CPUX86}                               // vbgtH[32rbg
  begin
    Memo1.Lines.Add('X86[h');
  end;
  {$ENDIF CPUX86}
  if power(1 - p, n) = 0 then begin             // mxvZmF
    MessageDlg('n  p 傫܂B', mtInformation, [mbOk], 0, mbOk);
    exit;
  end;
  Po := p_binomial(n, p, x);
  Qo := q_binomial(n, p, x);
  if checkbox1.Checked = true then
    fo := binomial_f(n, p, x)
  else
    fo := binomial_mass(n, p, x);
  Memo1.Lines.Add('@@mx f  ' + floatTostr(fo));
  Memo1.Lines.Add('ݐϊm P  ' + floatTostr(Po));
  Memo1.Lines.Add('㑤ݐϊm Q  ' + floatTostr(Qo));
  Memo1.Lines.Add('@Ғl  mean  ' + floatTostr(n * p));

  Po := 0;
  Qo := 0;
  Series1.Clear;
  for I := 0 to n do begin
    if checkbox1.Checked = true then
      fo := binomial_f(n, p, I)
    else
      fo := binomial_mass(n, p, I);
    if I < x then begin
      Series1.AddXY(I, fo, '', clred);
      Po := Po + fo;
    end;
    if I = x then begin
      Series1.AddXY(I, fo, '', clFuchsia);
      Po := Po + fo;
      Qo := Qo + fo;
    end;
    if I > x then begin
      Series1.AddXY(I, fo, '', clBlue);
      Qo := Qo + fo;
    end;
  end;
  Memo1.Lines.Add('ݐϊm fp  ' + floatTostr(Po));
  Memo1.Lines.Add('㑤ݐϊm fq  ' + floatTostr(Qo));
end;

end.
